#define F_CPU 12000000UL 
#include <math.h>
#include <avr/io.h>
#include <util/delay.h>

uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000;
    ADMUX |= channel;
    ADCSRA = 0b11000110;
    while ((ADCSRA & (1<<ADSC))); 
    return ADCL + ADCH*256;
}
main()
{
    long x = 0;
    int centimeter = 0;
    int meter = 0;
    int kilometer = 0;
    int inch = 0;
    int foot = 0;
    int mile = 0;
    DDRB = 0b000000;
    DDRD = 0b11100010;
    DDRC = 0b111111;
    //default in B to 1
    PORTB |= 0b111111;
    //out 0 to switch and default in to 1
    PORTD = 0b01;

    while (1)
    {
        //while not push (this have time not push long than push)
        if(PIND & 0b1)
        {
            //count++
            x = (x + 1);
            while(PIND & 0b1)
            {
                //led_check
                PORTD = (~x<<5)  | 0b01;
                if(~PINB & 0b1)
                {
                    //CENTIMETER_mode
                    centimeter = (int)(x * 7 * M_PI * 10 / 4.0);
                    PORTC = centimeter%10<<2 | 0b00;
                    _delay_ms(4);
                    PORTC = (centimeter/10)%10<<2 | 0b01;
                    _delay_ms(4);
                    PORTC = (centimeter/100)%10<<2 | 0b10;
                    _delay_ms(4);
                    PORTC = (centimeter/1000)%10<<2 | 0b11;
                    _delay_ms(4);
                }
                if(~PINB & 1 << 1)
                {
                    //METER_mode
                    meter = (int)(x * 7 * M_PI * 10 / 4.0 / 100);
                    PORTC = meter%10<<2 | 0b00;
                    _delay_ms(4);
                    PORTC = (meter/10)%10<<2 | 0b01;
                    _delay_ms(4);
                    PORTC = (meter/100)%10<<2 | 0b10;
                    _delay_ms(4);
                    PORTC = (meter/1000)%10<<2 | 0b11;
                    _delay_ms(4);
                }
                if(~PINB & 1 << 2)
                {
                    //KILOMETER_mode
                    kilometer = (int)(x * 7 * M_PI * 10 / 4.0 / 100000);
                    PORTC = kilometer%10<<2 | 0b00;
                    _delay_ms(4);
                    PORTC = (kilometer/10)%10<<2 | 0b01;
                    _delay_ms(4);
                    PORTC = (kilometer/100)%10<<2 | 0b10;
                    _delay_ms(4);
                    PORTC = (kilometer/1000)%10<<2 | 0b11;
                    _delay_ms(4);
                }
                if(~PINB & 1 << 3)
                {
                    //INCH_mode
                    inch = (int)(x * 7 * M_PI * 10 / 4.0 * 0.3937007874016);
                    PORTC = inch%10<<2 | 0b00;
                    _delay_ms(4);
                    PORTC = (inch/10)%10<<2 | 0b01;
                    _delay_ms(4);
                    PORTC = (inch/100)%10<<2 | 0b10;
                    _delay_ms(4);
                    PORTC = (inch/1000)%10<<2 | 0b11;
                    _delay_ms(4);
                }
                if(~PINB & 1 << 4)
                {
                    //FOOT_mode
                    foot = (int)(x * 7 * M_PI * 10 / 4.0 * 0.03280839895013);
                    PORTC = foot%10<<2 | 0b00;
                    _delay_ms(4);
                    PORTC = (foot/10)%10<<2 | 0b01;
                    _delay_ms(4);
                    PORTC = (foot/100)%10<<2 | 0b10;
                    _delay_ms(4);
                    PORTC = (foot/1000)%10<<2 | 0b11;
                    _delay_ms(4);
                }
                if(~PINB & 1 << 5)
                {
                    //RESET_mode
                    x = 0;
                    //MILE_mode
                    //mile = (int)(x * 7 * M_PI * 10 / 4.0 * 0.000006213711922373);
                    //PORTC = mile%10<<2 | 0b00;
                    //_delay_ms(4);
                    //PORTC = (mile/10)%10<<2 | 0b01;
                    //_delay_ms(4);
                    //PORTC = (mile/100)%10<<2 | 0b10;
                    //_delay_ms(4);
                    //PORTC = (mile/1000)%10<<2  | 0b11;
                    //_delay_ms(4);
                }
            }
        }
        //while push
        PORTD = 0b11100001; 
        if(~PINB & 0b1)
        {
            //CENTIMETER_mode
            centimeter = (int)(x * 7 * M_PI * 10 / 4.0);
            PORTC = centimeter%10<<2 | 0b00;
            _delay_ms(4);
            PORTC = (centimeter/10)%10<<2 | 0b01;
            _delay_ms(4);
            PORTC = (centimeter/100)%10<<2 | 0b10;
            _delay_ms(4);
            PORTC = (centimeter/1000)%10<<2 | 0b11;
            _delay_ms(4);
        }
        if(~PINB & 1 << 1)
        {
            //METER_mode
            meter = (int)(x * 7 * M_PI * 10 / 4.0 / 100);
            PORTC = meter%10<<2 | 0b00;
            _delay_ms(4);
            PORTC = (meter/10)%10<<2 | 0b01;
            _delay_ms(4);
            PORTC = (meter/100)%10<<2 | 0b10;
            _delay_ms(4);
            PORTC = (meter/1000)%10<<2 | 0b11;
            _delay_ms(4);
        }
        if(~PINB & 1 << 2)
        {
            //KILOMETER_mode
            kilometer = (int)(x * 7 * M_PI * 10 / 4.0 / 100000);
            PORTC = kilometer%10<<2 | 0b00;
            _delay_ms(4);
            PORTC = (kilometer/10)%10<<2 | 0b01;
            _delay_ms(4);
            PORTC = (kilometer/100)%10<<2 | 0b10;
            _delay_ms(4);
            PORTC = (kilometer/1000)%10<<2 | 0b11;
            _delay_ms(4);
        }
        if(~PINB & 1 << 3)
        {
            //INCH_mode
            inch = (int)(x * 7 * M_PI * 10 / 4.0 * 0.3937007874016);
            PORTC = inch%10<<2 | 0b00;
            _delay_ms(4);
            PORTC = (inch/10)%10<<2 | 0b01;
            _delay_ms(4);
            PORTC = (inch/100)%10<<2 | 0b10;
            _delay_ms(4);
            PORTC = (inch/1000)%10<<2 | 0b11;
            _delay_ms(4);
        }
        if(~PINB & 1 << 4)
        {
            //FOOT_mode
            foot = (int)(x * 7 * M_PI * 10 / 4.0 * 0.03280839895013);
            PORTC = foot%10<<2 | 0b00;
            _delay_ms(4);
            PORTC = (foot/10)%10<<2 | 0b01;
            _delay_ms(4);
            PORTC = (foot/100)%10<<2 | 0b10;
            _delay_ms(4);
            PORTC = (foot/1000)%10<<2 | 0b11;
            _delay_ms(4);
        }
        if(~PINB & 1 << 5)
        {
            //RESET_mode
            x = 0;
            //MILE_mode
            //mile = (int)(x * 7 * M_PI * 10 / 4.0 * 0.000006213711922373);
            //PORTC = mile%10<<2 | 0b00;
            //_delay_ms(4);
            //PORTC = (mile/10)%10<<2 | 0b01;
            //_delay_ms(4);
            //PORTC = (mile/100)%10<<2 | 0b10;
            //_delay_ms(4);
            //PORTC = (mile/1000)%10<<2 | 0b11;
            //_delay_ms(4);
        }
    }
}
